__trace("SP2010_1.0.js file");
var __alreadyinitiated = false;
var __alreadyloaded = false;

function __initEnvironmentAgent() {
	if  (__alreadyinitiated) return;
	__alreadyinitiated = true;
	
	__trace("__initEnvironmentAgent");
	var script = document.createElement("script");
	if (element.BrowserType != "ie") {
		script.onload = function() {
			__trace(element.AgentBaseLocation+" was loaded");
			__initSP2010Agent();
		}
	} else {
		script.onreadystatechange = function() {
			if (this.readyState == "loaded" || this.readyState == "complete") {
				__trace(element.AgentBaseLocation+" was loaded");
				__initSP2010Agent();
			} else __trace(element.AgentBaseLocation+" was not loaded yet ("+this.readyState+")");
		}
	}
	__trace("loading "+element.AgentBaseLocation);
	script.src = element.AgentBaseLocation;
	document.body.appendChild(script);
	script = null;
}

function __initSP2010Agent() {
	if (__alreadyloaded) return;
	__alreadyloaded = true;
	__trace("__initSP2010Agent");
		try { if (document.body.offsetWidth < 10) return; } catch (e) { __trace("hidden frame. ignore"); }

		__trace("__Page.readyState: "+__Page.readyState);
		if (__Page.readyState != "error") {
		    
		    // support anonymous access
			if (element.SupportAnonymousUsers) {
				__trace("SupportAnonymousUsers is on");
				__Page.username = GetUsername();
				__trace("__Page.username: "+__Page.username);
			}
			
			// support additional data to view events in param3
			if (element.Param3ElementName) {
				__trace("Param3ElementName is on");
				__Page.param3 = GetParam3ElementValue();
				__trace("__Page.param3: "+__Page.param3);
			}
			
			// set agent handler
			__Page.agent = "SP2010Agent";

			// handle exceptions (TOCHECK)
			__Page.customShouldContinue = __SP2010ShouldContinue;

			// populate Agent Object Model
			__Page.customInit = __SP2010CreateAOM;

			// set supported events by this agent
			__Page.events = {Visit:true, Leave:true, Search:true, SearchResultItem:true, SearchResultClick:true};

			// overwrite the event detection
			__EventHandler.New = __SP2010EventNew;

            // catch customready if special actions are needed based on custom values
            __Page.attachEvent("customready", __SP2010CreateCustom);
            
			initAgentBase();
			
			__trace("__Page.readyState: "+__Page.readyState);
			if (__Page.readyState == "ready") __Page.sendEvent(__SP2010NewVisit(), false, false);
		} else {
			__trace("Error loading MPSS2007Agent: "+__Page.errorDescription);
		    window.status = "Error loading SP2010Agent: "+__Page.errorDescription;
		    if (typeof(__Status) != "undefined") __Status.print("Error loading SP2010Agent: "+__Page.errorDescription);
		    else __Status = {output:new Array({o:"Error loading SP2010Agent: "+__Page.errorDescription})};
		}
}

function __SP2010EventNew(e) {
	__trace("__SP2010EventNew");
	var event = new __Event(e);
	__trace("__SP2010EventNew return: " + (event != null ? event.ToString() : "null"));
	return event;
}

function __SP2010NewVisit() {
	__trace("__SP2010NewVisit");
	var event = __EventHandler.NewVisit();
	__trace("__SP2010NewVisit return: " + (event != null ? event.ToString() : "null"));
	return event;
}

function __SP2010ShouldContinue() {
	return "ready";
}

function isSearchPage() {
	__trace("isSearchPage");
    var divs = document.getElementsByTagName("div"); 
    	__trace("document.getElementByTagName('div').length: "+divs.length);
    for (var i=0;i<divs.length;i++) { 
    	__trace("divs["+i+"].className: "+divs[i].className);
        if (divs[i].className == "srch-stats" || divs[i].className == "srch-sort-right") { 
        	__trace("isSearchPage return true");
            return true;
        }
    } 
    __trace("isSearchPage return false");
}

function __SP2010CreateAOM() {
	__trace("SP2010");
	__eTypes = {Page:0, Search:0};
	__eEvents = {Visit:{id:0, name:"Visit"},
				Leave:{id:1, name:"Leave"},
				Search:{id:2, name:"Search"},
				SearchResultItem:{id:4, name:"SearchResultItem"},
				SearchResultClick:{id:5, name:"SearchResultClick"},
				External:{id:10, name:"External"}
				};

	this.url = this.document.location.href;

    try {    
	    if (isSearchPage()) { //this.url.match(/\/Results\.aspx\?k=/i)) {
	    	__trace("this is a search page");
		    this.Search.readyState = "ready";
		    this.entityType = __eTypes.Search;
		    this.eventType = __eEvents.Search;
			
		__trace("fireEvent('onsearch')");

		    this.fireEvent("onsearch");

		    // find search term
		    var searchTermFromAdvanced = __Page.CookieHandler.Read("LastSearchTermFromAdvanced");
		    __trace("searchTermFromAdvanced: "+searchTermFromAdvanced);
		    var inputs = this.document.getElementsByTagName("input");
		    __trace("document.getElementsByTagName('input').length: "+inputs.length);
		    var searchInput = false;
		    for (var i=0;i<inputs.length;i++) {
		    	__trace("inputs["+i+"].id: "+inputs[i].id);
			    if (inputs[i].id.match(/InputKeywords$/i)) {
				    searchInput = inputs[i];
				    __trace("found search input: "+inputs[i].id+", "+inputs[i].value);
				    break;
			    }
		    }
		    if (searchInput) {
			    this.Search.Keyword = (searchInput.value.replace(/ /g) == "") ? searchTermFromAdvanced : escape(searchInput.value);
				__trace("this.Search.Keyword: "+this.Search.Keyword);
			    this.Search.Input = searchInput;

			    // find out number of results
			    var summaryBlock = this.document.getElementById("SRST");
				__trace("this.document.getElementById('SRST'): "+summaryBlock);
			    if (!summaryBlock) throw {description:"could not find SRST block"};

			    this.Search.EntityId = "N/A";
			    this.Search.NumberOfTotalResults = summaryBlock.innerHTML.replace(/^[^0-9]*[0-9]*-[0-9]*[^0-9]*([0-9,]*).*$/, "$1");
				__trace("summaryBlock.innerHTML: "+summaryBlock.innerHTML);
				__trace("NumberOfTotalResults string: "+this.Search.NumberOfTotalResults);
			    if (this.Search.NumberOfTotalResults == summaryBlock.innerHTML) this.Search.NumberOfTotalResults = 0;
			    else this.Search.NumberOfTotalResults = this.Search.NumberOfTotalResults.replace(/,/g, "");
				__trace("NumberOfTotalResults: "+this.Search.NumberOfTotalResults);

			    this.Search.FirstResultOnPage = parseInt(summaryBlock.innerHTML.replace(/^[^0-9,]*([0-9,]*).*$/, "$1"), 10);
				__trace("FirstResultOnPage string: "+summaryBlock.innerHTML.replace(/^[^0-9,]*([0-9,]*).*$/, "$1"));
			    if (isNaN(this.Search.FirstResultOnPage)) this.Search.FirstResultOnPage = 1;
			    	__trace("FirstResultOnPage: "+this.Search.FirstResultOnPage);

			    // get search results
			    var resultsDiv = this.document.getElementsByName("CSR");
				__trace("document.getElementsByName('CSR').length: "+resultsDiv.length);
			    if (resultsDiv.length == 0) {
			    	__trace("resultsDiv is empty, get document.getElementById('CSR'): "+document.getElementById("CSR"));
			    	resultsDiv = new Array(document.getElementById("CSR"));
			    }

			    var results;

			    if (typeof(resultsDiv) != "undefined" && resultsDiv.length > 0) results = (resultsDiv.length > 1) ? resultsDiv[1].getElementsByTagName("DIV") : resultsDiv[0].getElementsByTagName("DIV");
			    else results = new Array();
			
				__trace("results.length: "+results.length);
			    for (var i=0;i<results.length;i++) {
			    	__trace("results["+i+"].className: "+results[i].className);
				    if (results[i].className == "srch-Title2") {
					    var currA = results[i].getElementsByTagName("a")[0];
					    __trace("result #"+i+" link: "+currA);
					    if (currA) currA.__type = __eEvents.SearchResultItem;
					    this.Search.Results[this.Search.Results.length] = currA;
				    }
			    }
		    } else {
		    	__trace("Could not find search input");
		    	throw {description:"could not find search input"};
		    }
	    } else {
	    	__trace("this is a regular page");
		    this.eventType = __eEvents.Visit;
		    __trace("fireEvent('onvisit')");
		    this.fireEvent("onvisit");
		    // check type of page
		    this.entityType = __eTypes.Page;
	    }

    } catch (e) {
    }
	__trace("fireEvent('onload')");
	this.fireEvent("onload");
}

function __SP2010CreateCustom() {
    // check if advanced, add keyword to cookie
    __trace("__SP2010CreateCustom");
    var isAdvanced = false;
    __trace("AdvancedSearchPages.length: "+AdvancedSearchPages.length);
    for (var i=0;i<AdvancedSearchPages.length;i++) {
    	__trace(i+": "+AdvancedSearchPages[i]);
        var re = new RegExp(AdvancedSearchPages[i], "i");
        if (document.location.href.match(re)) {
        	__trace("isAdvanced is true");
            isAdvanced = true;
            __captureSearchTerm();
        }
    }
    if (!isAdvanced) {
    	__trace("isAdvanced is false, delete LastSearchTermFromAdvacned");
    	__Page.CookieHandler.Delete("LastSearchTermFromAdvanced");
    }
}

function __captureSearchTerm() {
	__trace("__captureSearchTerm");
    var inputs = document.getElementsByTagName("input");
	__trace("document.getElementsByTagName('input').length: "+inputs.length);
    for (var i=0;i<inputs.length;i++) {
    	__trace("inputs["+i+"].type: "+inputs[i].type);
        if (inputs[i].type == "submit") {
            if (inputs[i].attachEvent) {
                inputs[i].attachEvent("onclick", function() {
                    for (var i=0;i<inputs.length;i++) {
                        if (inputs[i].type == "text" && inputs[i].value.replace(/ /g) != "") {
                            __Page.CookieHandler.Save("LastSearchTermFromAdvanced", inputs[i].value); 
                            break;
                        }
                    }
                });
            } else {
                try {
                    inputs[i].addEventListener("click", function() {
                        for (var i=0;i<inputs.length;i++) {
                            if (inputs[i].type == "text" && inputs[i].value.replace(/ /g) != "") {
                                __Page.CookieHandler.Save("LastSearchTermFromAdvanced", inputs[i].value); 
                                break;
                            }
                        }
                    }, false);
                } catch (e) {
                }
            }
        }
    }
}